<template>
  <div>
    <div v-if="productlist.length">
      <table>
        <th></th>
        <th>Название</th>
        <th>Цена</th>
        <th>Количество</th>
        <th>Действие</th>
        <tr v-for="product in productlist" :key="product.id">
          <td>
            <img
              class="image_product"
              :src="require(`@/assets/images/${product.image}`)"
            />
          </td>
          <td>{{ product.name }}</td>
          <td>{{ product.price }}</td>
          <td>
            <ChangeCountProduct :id="product.id" :count="product.count" />
          </td>
          <td><button @click="deleteProduct(product.id)">Удалить</button></td>
        </tr>
      </table>

      <button type="button" class="btn-delete" @click="deleteAll">
        Удалить все
      </button>
    </div>
    <p v-else>
      Корзина пустая
    </p>
  </div>
</template>
<script>
import { mapState } from 'vuex'
import ChangeCountProduct from './ChangeCountProduct'
export default {
  name: 'ProductList',
  components: {
    ChangeCountProduct
  },
  computed: mapState({
    productlist: state =>
      state.productlist.sort((a, b) => new Date(b.date) - new Date(a.date)) // Сортировка товара по времени добавления
  }),
  methods: {
    deleteProduct: function(id) {
      this.$store.dispatch('deleteProduct', id)
    },
    deleteAll: function() {
      this.$store.dispatch('deleteAll')
    }
  }
}
</script>
<style lang="scss">
.btn-delete {
  margin: 15px 10px;
  background: rgb(219, 9, 9);
  border: 1px solid;
  border-radius: 10px;
  padding: 10px 15px;
  color: #ffffff;
  cursor: pointer;
  &:hover {
    background: rgb(175, 7, 7);
  }
}
.image_product {
  max-width: 75px;
  width: 100%;
}
table {
  td {
    padding: 0px 10px;
  }
}
</style>
